#include "stdio.h"
#include "string.h"

FILE *i,*o;
unsigned int z;
int m,r,c,cc,h,l;
char icon[21][24][12],mapndx=16,fname[257],map[32][32];

main(int na, char **a)
{

if (na<2) { fprintf(stderr,"Syntax:  XORMAP dumpfile\n"); return 1; }

/* get output file name and open file */
strcpy(fname,a[1]);
for (m=strlen(fname); m; m--) if (fname[m]=='.') break;
if (!m) { m=strlen(fname); strcpy(fname+m,"."); }
m++; strcpy(fname+m,"bmp");
o=fopen(fname,"wb");

/* Read icons and copy palette */
i=fopen("xoricon.bmp","rb");
fread(fname,0x76,1,i);  /* copy xoricons.bmp header into buffer */
/* now alter it from 504x24x16 to 768x768x16 */
fname[2]=0x76;    /* significance?? */
fname[3]=0x80;    /* don't know here either */
fname[4]=4;       /* nor here */
fname[0x12]=0;    /* 504->768 (low) */
fname[0x13]=3;    /* 504->768 (high) */
fname[0x16]=0;    /* 24->768 (low) */
fname[0x17]=3;    /* 24->768 (high) */
fname[0x22]=0;    /* significance unknown */
fname[0x23]=0x80; /* and here */
fname[0x24]=4;    /* and here */
fwrite(fname,0x76,1,o); /* write modified header */
/* now read icons */
for (r=0; r<24; r++)
    for (z=0; z<21; z++)
        for (c=0; c<12; c++) icon[z][r][c]=getc(i);
fclose(i);

/* generate image */
i=fopen(a[1],"rb");
for (z=0; z<0x80; z++) getc(i); /* skip tape-image header */
for (r=0; r<32; r++)
    for (c=0; c<32; c++) {
	cc=getc(i);
        if (cc==4) {
			  cc=mapndx;
           if (mapndx>4) { mapndx++; if (mapndx==20) mapndx=4; }
           }
        else if (cc>=16) cc=20;
        map[r][c]=cc;
        }
fclose(i);
for (r=31; r>=0; r--)
    for (m=0; m<24; m++)
        for (c=0; c<32; c++) {
            z=map[r][c];
            for (cc=0; cc<12; cc++) putc(icon[z][m][cc],o);
            }
fclose(o); return 0;
}
